# Functors.jl

[![][docs-stable-img]][docs-stable-url]
[![][docs-dev-img]][docs-dev-url]
[![][action-img]][action-url]

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://fluxml.ai/Functors.jl/stable/

[docs-dev-img]: https://img.shields.io/badge/docs-dev-blue.svg
[docs-dev-url]: https://fluxml.ai/Functors.jl/dev/

[action-img]: https://github.com/FluxML/Functors.jl/workflows/CI/badge.svg
[action-url]: https://github.com/FluxML/Functors.jl/actions

Functors.jl provides tools to express a powerful design pattern for dealing with large / nested structures, as in machine learning and optimisation. For large machine learning models it can be cumbersome or inefficient to work with parameters as one big, flat vector, and structs help manage complexity; but it is also desirable to easily operate over all parameters at once, e.g. for changing precision or applying an optimiser update step.

## Basic Usage

Functors.jl provides `fmap` to make those things easy, acting as a 'map over parameters':

```julia
julia> using Functors

julia> struct Foo
         x
         y
       end

julia> model = Foo(1, [1, 2, 3])
Foo(1, [1, 2, 3])

julia> fmap(float, model)
Foo(1.0, [1.0, 2.0, 3.0])
```

It works also with deeply-nested models:

```julia
julia> struct Bar
         x
       end

julia> model = Bar(Foo(1, [1, 2, 3]))
Bar(Foo(1, [1, 2, 3]))

julia> fmap(float, model)
Bar(Foo(1.0, [1.0, 2.0, 3.0]))
```

> [!NOTE]
> Up to to v0.4, Functors.jl's functionality had to be opted in on custom types via the `@functor Foo` macro call. 
> With v0.5 instead, this is no longer necessary: by default any type is recursively traversed up to the leaves
> and `ConstructionBase.constructorof` is used to reconstruct it.
> In order to opt-out of this behaviour and make a type non traversable you can use `@leaf Foo`.
>
> Most users should be unaffected by the change and could remove `@functor` from their custom types.

## Further Details

The workhorse of `fmap` is actually a lower level function, `functor`:

```julia
julia> children, reconstruct = Functors.functor(Foo(1, [1, 2, 3]))
((x = 1, y = [1, 2, 3]), Functors.var"#3#6"{DataType}(Foo))

julia> reconstruct(map(float, children))
Foo(1.0, [1.0, 2.0, 3.0])
```

`functor` returns the parts of the object that can be inspected, as well as a `reconstruct` function that takes those values and restructures them back into an object of the original type.

To include only certain fields, pass a tuple of field names to `@functor`:

```julia
julia> struct Baz
         x
         y
       end

julia> @functor Baz (x,)

julia> model = Baz(1, 2)
Baz(1, 2)

julia> fmap(float, model)
Baz(1.0, 2)
```

Any field not in the list will not be returned by `functor` and passed through as-is during reconstruction. This is done by invoking the default constructor, so structs that define custom inner constructors are expected to provide one that acts like the default.

It is also possible to implement `functor` by hand when greater flexibility is required. See [here](https://github.com/FluxML/Functors.jl/issues/3) for an example.

For a discussion regarding the need for a `cache` in the implementation of `fmap`, see [here](https://github.com/FluxML/Functors.jl/issues/2).

Use `exclude` for more fine-grained control over whether `fmap` descends into a particular value (the default is `exclude = Functors.isleaf`):

```julia
julia> using CUDA

julia> x = ['a', 'b', 'c'];

julia> fmap(cu, x)
3-element Array{Char,1}:
 'a': ASCII/Unicode U+0061 (category Ll: Letter, lowercase)
 'b': ASCII/Unicode U+0062 (category Ll: Letter, lowercase)
 'c': ASCII/Unicode U+0063 (category Ll: Letter, lowercase)

julia> fmap(cu, x; exclude = x -> CUDA.isbitstype(eltype(x)))
3-element CuArray{Char,1}:
 'a': ASCII/Unicode U+0061 (category Ll: Letter, lowercase)
 'b': ASCII/Unicode U+0062 (category Ll: Letter, lowercase)
 'c': ASCII/Unicode U+0063 (category Ll: Letter, lowercase)
```

## Related Packages
- [StructWalk.jl](https://github.com/chengchingwen/StructWalk.jl)

using Base: tail

KeyT = Union{Symbol, AbstractString, Integer, CartesianIndex}

"""
    KeyPath(keys...)

A type for representing a path of keys to a value in a nested structure.
Can be constructed with a sequence of keys, or by concatenating other `KeyPath`s.
Keys can be of type `Symbol`, `String`, `Int`, or `CartesianIndex`.

For custom types, access through symbol keys is assumed to be done with `getproperty`.
For consistency, the method `Base.propertynames` is used to get the viable property names.

For string, integer, and cartesian index keys, the access is done with `getindex` instead.

See also [`getkeypath`](@ref), [`haskeypath`](@ref).

# Examples

```jldoctest
julia> kp = KeyPath(:b, 3)
KeyPath(:b, 3)

julia> KeyPath(:a, kp, :c, 4) # construct mixing keys and keypaths
KeyPath(:a, :b, 3, :c, 4)

julia> struct T
           a
           b
       end

julia> function Base.getproperty(x::T, k::Symbol)
            if k in fieldnames(T)
                return getfield(x, k)
            elseif k === :ab
                return "ab"
            else        
                error()
            end
        end;

julia> Base.propertynames(::T) = (:a, :b, :ab);

julia> x = T(3, Dict(:c => 4, :d => 5));

julia> getkeypath(x, KeyPath(:ab)) # equivalent to x.ab
"ab"

julia> getkeypath(x, KeyPath(:b, :c)) # equivalent to (x.b)[:c]
4
```
"""
struct KeyPath{T<:Tuple}
    keys::T    
end

isleaf(::KeyPath, @nospecialize(x)) = isleaf(x)

function KeyPath(keys::Union{KeyT, KeyPath}...)
    ks = (k isa KeyPath ? (k.keys...,) : (k,) for k in keys)
    return KeyPath(((ks...)...,))
end

Base.isempty(kp::KeyPath) = false
Base.isempty(kp::KeyPath{Tuple{}}) = true
Base.getindex(kp::KeyPath, i::Integer) = kp.keys[i]
Base.getindex(kp::KeyPath, r::AbstractVector) = KeyPath(kp.keys[r])
Base.last(kp::KeyPath) = last(kp.keys)
Base.lastindex(kp::KeyPath) = lastindex(kp.keys)
Base.length(kp::KeyPath) = length(kp.keys)
Base.iterate(kp::KeyPath, state=1) = iterate(kp.keys, state)
Base.tail(kp::KeyPath) = KeyPath(Base.tail(kp.keys))
Base.:(==)(kp1::KeyPath, kp2::KeyPath) = kp1.keys == kp2.keys

function Base.show(io::IO, kp::KeyPath)
    compat = get(io, :compact, false)
    if compat
        print(io, keypathstr(kp))          
    else
        print(io, "KeyPath$(kp.keys)")
    end
end

keypathstr(kp::KeyPath) = join(kp.keys, ".")

_getkey(x, k::Integer) = x[k]
_getkey(x::AbstractArray, k::CartesianIndex) = x[k]
_getkey(x, k::Symbol) = getproperty(x, k)
_getkey(x::AbstractDict, k::Symbol) = x[k]
_getkey(x, k::AbstractString) = x[k]

_setkey!(x, k::Integer, v) = (x[k] = v)
_setkey!(x::AbstractArray, k::CartesianIndex, v) = (x[k] = v)
_setkey!(x, k::Symbol, v) = setproperty!(x, k, v)
_setkey!(x::AbstractDict, k::Symbol, v) = (x[k] = v)
_setkey!(x, k::AbstractString, v) = (x[k] = v)

_haskey(x, k::Integer) = haskey(x, k)
_haskey(x::Tuple, k::Integer) = 1 <= k <= length(x)
_haskey(x::AbstractArray, k::Integer) = 1 <= k <= length(x) # TODO: extend to generic indexing
_haskey(x::AbstractArray, k::CartesianIndex) = checkbounds(Bool, x, k)
_haskey(x, k::Symbol) = k in propertynames(x)
_haskey(x::AbstractDict, k::Symbol) = haskey(x, k)
_haskey(x, k::AbstractString) = haskey(x, k)


"""
    getkeypath(x, kp::KeyPath)

Return the value in `x` at the path `kp`.

See also [`KeyPath`](@ref), [`haskeypath`](@ref), and [`setkeypath!`](@ref).

# Examples
```jldoctest
julia> x = Dict(:a => 3, :b => Dict(:c => 4, "d" => [5, 6, 7]))
Dict{Symbol, Any} with 2 entries:
  :a => 3
  :b => Dict{Any, Any}(:c=>4, "d"=>[5, 6, 7])

julia> getkeypath(x, KeyPath(:b, "d", 2))
6
```
"""
function getkeypath(x, kp::KeyPath)
    if isempty(kp)
        return x
    else
        return getkeypath(_getkey(x, first(kp)), tail(kp))
    end
end

"""
    haskeypath(x, kp::KeyPath)

Return `true` if `x` has a value at the path `kp`.

See also [`KeyPath`](@ref), [`getkeypath`](@ref), and [`setkeypath!`](@ref).

# Examples
```jldoctest
julia> x = Dict(:a => 3, :b => Dict(:c => 4, "d" => [5, 6, 7]))
Dict{Symbol, Any} with 2 entries:
  :a => 3
  :b => Dict{Any, Any}(:c=>4, "d"=>[5, 6, 7])

julia> haskeypath(x, KeyPath(:a))
true

julia> haskeypath(x, KeyPath(:b, "d", 1))
true

julia> haskeypath(x, KeyPath(:b, "d", 4))
false
```
"""
function haskeypath(x, kp::KeyPath)
    if isempty(kp)
        return true
    else
        k = first(kp)
        return _haskey(x, k) && haskeypath(_getkey(x, k), tail(kp))
    end
end

"""
    setkeypath!(x, kp::KeyPath, v)

Set the value in `x` at the path `kp` to `v`.

See also [`KeyPath`](@ref), [`getkeypath`](@ref), and [`haskeypath`](@ref).
"""
function setkeypath!(x, kp::KeyPath, v)
    if isempty(kp)
        error("Empty keypath not allowed.")
    end
    y = getkeypath(x, kp[1:end-1])
    k = kp[end]
    return _setkey!(y, k, v)
end

function functor end

const NoChildren = Tuple{}

"""
    @leaf T

Define [`functor`](@ref Functors.functor) for the type `T` so that  `isleaf(x::T) == true`.
"""
macro leaf(T)
  :($Functors.functor(::Type{<:$(esc(T))}, x) = ($Functors.NoChildren(), _ -> x))
end

# Default functor
function functor(T, x)
  names = fieldnames(T)
  if isempty(names)
    return NoChildren(), _ -> x
  end
  S = constructorof(T) # remove parameters from parametric types and support anonymous functions
  vals = ntuple(i -> getfield(x, names[i]), length(names))
  return NamedTuple{names}(vals), y -> S(y...)
end

functor(x) = functor(typeof(x), x)

function makefunctor(m::Module, T, fs = fieldnames(T))
  fidx = Ref(0)
  escargs = map(fieldnames(T)) do f
    f in fs ? :(y[$(fidx[] += 1)]) : :(x.$f)
  end
  escargs_nt = map(fieldnames(T)) do f
    f in fs ? :(y[$(Meta.quot(f))]) : :(x.$f)
  end
  escfs = [:($f=x.$f) for f in fs]
  
  @eval m begin
    function $Functors.functor(::Type{<:$T}, x)
      reconstruct(y) = $T($(escargs...))
      reconstruct(y::NamedTuple) = $T($(escargs_nt...))
      return (;$(escfs...)), reconstruct
    end
  end
end

function functorm(T, fs = nothing)
  fs === nothing || Meta.isexpr(fs, :tuple) || error("@functor T (a, b)")
  fs = fs === nothing ? [] : [:($(map(QuoteNode, fs.args)...),)]
  :(makefunctor(@__MODULE__, $(esc(T)), $(fs...)))
end

macro functor(args...)
  functorm(args...)
end

isleaf(@nospecialize(x)) = children(x) === NoChildren()

children(x) = functor(x)[1]

###
### FlexibleFunctors.jl
###

function makeflexiblefunctor(m::Module, T, pfield)
  pfield = QuoteNode(pfield)
  @eval m begin
    function $Functors.functor(::Type{<:$T}, x)
      pfields = getproperty(x, $pfield)
      function re(y)
        all_args = map(fn -> getproperty(fn in pfields ? y : x, fn), fieldnames($T))
        return $T(all_args...)
      end
      func = NamedTuple{pfields}(map(p -> getproperty(x, p), pfields))
      return func, re
    end
  end
end

function flexiblefunctorm(T, pfield = :params)
  pfield isa Symbol || error("@flexiblefunctor T param_field")
  pfield = QuoteNode(pfield)
  :(makeflexiblefunctor(@__MODULE__, $(esc(T)), $(esc(pfield))))
end

macro flexiblefunctor(args...)
  flexiblefunctorm(args...)
end

using Functors: functor, usecache

struct Foo; x; y; end

Base.:(==)(x::Foo, y::Foo) = x.x == y.x && x.y == y.y

struct Bar{T}; x::T; end

Base.:(==)(x::Bar, y::Bar) = x.x == y.x

struct OneChild3; x; y; z; end
@functor OneChild3 (y,)

struct NoChild2; x; y; end
@functor NoChild2 ()

struct NoChild1{T}; x::T; end
@functor NoChild1 ()

struct WrongOrder; x; y; z; end
@functor WrongOrder (z, x)

struct LeafType{T}; x::T; end
@leaf LeafType

###
### Basic functionality
###

@testset "NoChild is not a leaf" begin
  no_children = NoChild2(1, 2)
  has_children = Foo(1, 2)
  @test !Functors.isleaf(no_children)
  @test !Functors.isleaf(has_children)
  @test Functors.children(no_children) === (;)
  @test Functors.children(has_children) == (x=1, y=2)
end

@testset "Nested" begin
  model = Bar(Foo(1, [1, 2, 3]))

  model′ = fmap(float, model)

  @test model.x.y == model′.x.y
  @test model′.x.y isa Vector{Float64}
end

@testset "Exclude" begin
  f(x::AbstractArray) = x
  f(x::Char) = 'z'

  x = ['a', 'b', 'c']
  @test fmap(f, x)  == ['z', 'z', 'z']
  @test fmap(f, x; exclude = x -> x isa AbstractArray) == x

  x = (['a', 'b', 'c'], ['d', 'e', 'f'])
  @test fmap(f, x)  == (['z', 'z', 'z'], ['z', 'z', 'z'])
  @test fmap(f, x; exclude = x -> x isa AbstractArray) == x
end

@testset "Property list" begin
  model = OneChild3(1, 2, 3)
  model′ = fmap(x -> 2x, model)
  @test (model′.x, model′.y, model′.z) == (1, 4, 3)

  model = WrongOrder(1, 2, 3)
  model′ = fmap(x -> 2x, model)
  @test (model′.x, model′.y, model′.z) == (2, 2, 6)
end

@testset "Sharing" begin
  shared = [1,2,3]
  m1 = Foo(shared, Foo([1,2,3], Foo(shared, [1,2,3])))
  m1f = fmap(float, m1)
  @test m1f.x === m1f.y.y.x
  @test m1f.x !== m1f.y.x
  m1p = fmapstructure(identity, m1; prune = nothing)
  @test m1p == (x = [1, 2, 3], y = (x = [1, 2, 3], y = (x = nothing, y = [1, 2, 3])))
  m1no = fmap(float, m1; cache = nothing)  # disable the cache by hand
  @test m1no.x !== m1no.y.y.x

  # Here "4" is not shared, because Foo isn't leaf:
  m2 = Foo(Foo(shared, 4), Foo(shared, 4))
  @test m2.x === m2.y
  m2f = fmap(float, m2)
  @test m2f.x.x === m2f.y.x
  m2p = fmapstructure(identity, m2; prune = Bar(0))
  @test m2p == (x = (x = [1, 2, 3], y = 4), y = (x = Bar{Int64}(0), y = 4))

  # Repeated isbits types should not automatically be regarded as shared:
  m3 = Foo(Foo(shared, 1:3), Foo(1:3, shared))
  m3p = fmapstructure(identity, m3; prune = 0)
  @test m3p.y.y == 0
  @test m3p.y.x == 1:3

  # All-isbits trees need not create a cache at all:
  m4 = (x=1, y=(2, 3), z=4:5)
  @test isbits(fmap(float, m4))
  @test_skip 0 == @allocated fmap(float, m4)  # true, but fails in tests

  # Shared mutable containers are preserved, even if all children are isbits:
  ref = Ref(1)
  m5 = (x = ref, y = ref, z = Ref(1))
  m5f = fmap(x -> x/2, m5)
  @test m5f.x === m5f.y
  @test m5f.x !== m5f.z

  @testset "usecache ($d)" for d in [IdDict(), Base.IdSet()]
    # Leaf types:
    @test usecache(d, [1,2])
    @test !usecache(d, 4.0)
    @test usecache(d, LeafType([1,2]))
    @test !usecache(d, LeafType((3,4)))

    # Not leaf:
    @test usecache(d, Ref(3))  # mutable container
    @test !usecache(d, (5, 6.0))
    @test !usecache(d, (a = 2pi, b = missing))

    @test !usecache(d, (5, [6.0]'))  # contains mutable
    @test !usecache(d, (x = [1,2,3], y = 4))

    usecache(d, OneChild3([1,2], 3, nothing))  # mutable isn't a child, do we care?

    # No dictionary:
    @test !usecache(nothing, [1,2])
    @test !usecache(nothing, 3)
  end
end

@testset "Self-referencing types" begin
   # https://github.com/FluxML/Functors.jl/pull/72/ 
    @test fmap(identity, Base.ImmutableDict(:a => 42)) == Base.ImmutableDict(:a => 42)
    nt = fmap(x -> 2x, (; a = 1 ± 0.1, b = 2 ± 0.2))
    @test nt == (; a = 2 ± 0.2, b = 4 ± 0.4)
end

@testset "functor(typeof(x), y) from @functor" begin
  nt1, re1 = functor(Foo, (x=1, y=2, z=3))
  @test nt1 == (x = 1, y = 2)
  @test re1((x = 10, y = 20)) == Foo(10, 20)
  re1((y = 22, x = 11)) # gives Foo(22, 11), is that a bug?

  nt2, re2 = functor(Foo, (z=33, x=1, y=2))
  @test nt2 == (x = 1, y = 2)
  @test re2((x = 10, y = 20)) == Foo(10, 20)

  @test_throws Exception functor(Foo, (z=33, x=1))  # type NamedTuple has no field y

  nt3, re3 = functor(OneChild3, (x=1, y=2, z=3))
  @test nt3 == (y = 2,)
  @test re3((y = 20,)) == OneChild3(1, 20, 3)
  re3(22) # gives OneChild3(1, 22, 3), is that a bug?
end

@testset "functor(typeof(x), y) for Base types" begin
  nt11, re11 = functor(NamedTuple{(:x, :y)}, (x=1, y=2, z=3))
  @test nt11 == (x = 1, y = 2)
  @test re11((x = 10, y = 20)) == (x = 10, y = 20)
  re11((y = 22, x = 11))
  re11((11, 22))  # passes right through

  nt12, re12 = functor(NamedTuple{(:x, :y)}, (z=33, x=1, y=2))
  @test nt12 == (x = 1, y = 2)
  @test re12((x = 10, y = 20)) == (x = 10, y = 20)

  @test_throws Exception functor(NamedTuple{(:x, :y)}, (z=33, x=1))
end

@testset "anonymous functions" begin  
  model = let W = rand(2,2), b = ones(2)
    x -> tanh.(W*x .+ b)
  end
  newmodel = fmap(zero, model)
  @test newmodel isa Function
  @test newmodel([1,2]) == [0,0]
  @test newmodel.W == [0 0; 0 0]
  @test newmodel.b == [0, 0]  
end

###
### Extras
###

@testset "Walk" begin
  model = Foo((0, Bar([1, 2, 3])), [4, 5])

  model′ = fmapstructure(identity, model)
  @test model′ == (; x=(0, (; x=[1, 2, 3])), y=[4, 5])
end

@testset "fcollect" begin
  m1 = [1, 2, 3]
  m2 = 1
  m3 = Foo(m1, m2)
  m4 = Bar(m3)
  @test all(fcollect(m4) .=== [m4, m3, m1, m2])
  @test all(fcollect(m4, exclude = x -> x isa Array) .=== [m4, m3, m2])
  @test all(fcollect(m4, exclude = x -> x isa Foo) .=== [m4])

  m1 = [1, 2, 3]
  m2 = Bar(m1)
  m0 = NoChild2(:a, :b)
  m3 = Foo(m2, m0)
  m4 = Bar(m3)
  @test all(fcollect(m4) .=== [m4, m3, m2, m1, m0])

  m1 = [1, 2, 3]
  m2 = [1, 2, 3]
  m3 = Foo(m1, m2)
  @test all(fcollect(m3) .=== [m3, m1, m2])

  m1 = [1, 2, 3]
  m2 = SVector{length(m1)}(m1)
  m2′ = SVector{length(m1)}(m1)
  m3 = Foo(m1, m1)
  m4 = Foo(m2, m2′)
  @test all(fcollect(m3) .=== [m3, m1])
  @test all(fcollect(m4) .=== [m4, m2, m2′])
end

###
### Vararg forms
###

@testset "fmap(f, x, y)" begin
  m1 = (x = [1,2], y = 3)
  n1 = (x = [4,5], y = 6)
  @test fmap(+, m1, n1) == (x = [5, 7], y = 9)

  # Reconstruction type comes from the first argument
  foo1 = Foo([7,8], 9)
  @test fmap(+, m1, foo1) == (x = [8, 10], y = 12)
  @test fmap(+, foo1, n1) isa Foo
  @test fmap(+, foo1, n1).x == [11, 13]

  # Mismatched trees should be an error
  m2 = (x = [1,2], y = (a = [3,4], b = 5))
  n2 = (x = [6,7], y = 8)
  @test_throws Exception fmap(first∘tuple, m2, n2)  # ERROR: type Int64 has no field a

  # The cache uses IDs from the first argument
  shared = [1,2,3]
  m3 = (x = shared, y = [4,5,6], z = shared)
  n3 = (x = shared, y = shared, z = [7,8,9])
  @test fmap(+, m3, n3) == (x = [2, 4, 6], y = [5, 7, 9], z = [2, 4, 6])
  z3 = fmap(+, m3, n3)
  @test z3.x === z3.z

  # Pruning of duplicates:
  @test fmap(+, m3, n3; prune = nothing) == (x = [2,4,6], y = [5,7,9], z = nothing)

  # More than two arguments:
  z4 = fmap(+, m3, n3, m3, n3)
  @test z4 == fmap(x -> 2x, z3)
  @test z4.x === z4.z

  @test fmap(+, foo1, m1, n1) isa Foo
  @test fmap(.*, m1, foo1, n1) == (x = [4*7, 2*5*8], y = 3*6*9)
end


@testset "fmapstructure(f, x, y)" begin
  m1 = Foo([1,2], 3)
  n1 = Foo([4,5], 6)
  @test fmapstructure(+, m1, n1) == (x = [5, 7], y = 9)

  # Mismatched trees should be an error
  m2 = (x = [1,2], y = (a = [3,4], b = 5))
  n2 = (x = [6,7], y = 8)
  @test_throws Exception fmapstructure(first∘tuple, m2, n2)

  # The cache uses IDs from the first argument
  shared = [1,2,3]
  m3 = (x = shared, y = [4,5,6], z = shared)
  n3 = (x = shared, y = shared, z = [7,8,9])
  @test fmapstructure(+, m3, n3) == (x = [2, 4, 6], y = [5, 7, 9], z = [2, 4, 6])
  z3 = fmapstructure(+, m3, n3)
  @test z3.x === z3.z

  # Pruning of duplicates:
  @test fmapstructure(+, m3, n3; prune = nothing) == (x = [2,4,6], y = [5,7,9], z = nothing)

  # More than two arguments:
  z4 = fmapstructure(+, m3, n3, m3, n3)
  @test z4 == fmapstructure(x -> 2x, z3)
  @test z4.x === z4.z

  foo1 = Foo([7,8], 9)
  @test fmapstructure(.*, foo1, m1, n1) == (x = [4*7, 2*5*8], y = 3*6*9)
end

@testset "old test update.jl" begin
  struct M{F,T,S}
    σ::F
    W::T
    b::S
  end

  @functor M

  (m::M)(x) = m.σ.(m.W * x .+ m.b)

  m = M(identity, ones(Float32, 3, 4), zeros(Float32, 3))
  x = ones(Float32, 4, 2)
  m̄, _ = gradient((m,x) -> sum(m(x)), m, x)
  m̂ = Functors.fmap(m, m̄) do x, y
    isnothing(x) && return y
    isnothing(y) && return x
    x .- 0.1f0 .* y
  end

  @test m̂.W ≈ fill(0.8f0, size(m.W))
  @test m̂.b ≈ fill(-0.2f0, size(m.b))
end

@testset "parametric types" begin
  struct A{T}
    x::T
  end

  a = A(1)
  @test fmap(x -> x/2, a) == A(0.5)
end

@testset "Dict" begin
  d = Dict(:a => 1, :b => 2)
  
  @test Functors.children(d) == d
  @test fmap(x -> x + 1, d) == Dict(:a => 2, :b => 3)

  d = Dict(:a => 1, :b => Dict("a" => 5, "b" => 6, "c" => 7))  
  @test Functors.children(d) == d
  @test fmap(x -> x + 1, d) == Dict(:a => 2, :b => Dict("a" => 6, "b" => 7, "c" => 8))

  @testset "fmap(+, x, y)" begin
    m1 = Dict("x" => [1,2], "y" => 3)
    n1 = Dict("x" => [4,5], "y" => 6)
    @test fmap(+, m1, n1) == Dict("x" => [5, 7], "y" => 9)
    
    m1 = Dict(:x => [1,2], :y => 3)
    n1 = (x = [4,5], y = 6)
    @test fmap(+, m1, n1) == Dict(:x => [5, 7], :y => 9)

    # extra keys in n1 are ignored
    m1 = Dict("x" => [1,2], "y" => Dict(:a => 3, :b => 4))
    n1 = Dict("x" => [4,5], "y" => Dict(:a => 0.1, :b => 0.2, :c => 5), "z" => Dict(:a => 5))
    @test fmap(+, m1, n1) == Dict("x" => [5, 7], "y" => Dict(:a=>3.1, :b=>4.2))
  end
end

@testset "@leaf" begin
  struct B; x; end
  Functors.@leaf B
  b = B(1)
  children, re = Functors.functor(b)
  @test re(children) === b
  
  a = LeafType(1)
  children, re = Functors.functor(a)
  @test children == Functors.NoChildren()
  @test re(children) === a 
end

@testset "IterateWalk" begin
    x = ([1, 2, 3], 4, (5, 6, [7, 8]));
    make_iterator(x) = x isa AbstractVector ? x.^2 : (x^2,);
    iter = fmap(make_iterator, x; walk=Functors.IterateWalk(), cache=nothing);
    @test iter isa Iterators.Flatten
    @test collect(iter) == [1, 2, 3, 4, 5, 6, 7, 8].^2

    # Test iteration of multiple trees together
    y = ([8, 7, 6], 5, (4, 3, [2, 1]));
    make_zipped_iterator(x, y) = zip(make_iterator(x), make_iterator(y));
    zipped_iter = fmap(make_zipped_iterator, x, y; walk=Functors.IterateWalk(), cache=nothing);
    @test zipped_iter isa Iterators.Flatten
    @test collect(zipped_iter) == collect(Iterators.zip([1, 2, 3, 4, 5, 6, 7, 8].^2, [8, 7, 6, 5, 4, 3, 2, 1].^2))
end

@testset "Deprecated first-arg walk API to fmap" begin
  @test (@test_deprecated fmap(Functors.DefaultWalk(), nothing, (1, 2, 3))) == (1, 2, 3)
end

@testset "fleaves" begin
  x = (1, (2, 3), (a=4, b=(5, 6), c=7));
  @test fleaves(x) == [1, 2, 3, 4, 5, 6, 7]
  @test fleaves(x, exclude=x -> Functors.isleaf(x) || (x isa NamedTuple)) == [1, 2, 3, (a = 4, b = (5, 6), c = 7)]

  x = Dict("a" => Foo(1, 2), "b" => Bar([1,2,3]))
  xflat = fleaves(x)
  # @test xflat== [1, 2, [1, 2, 3]] # cannot guarantee ordering with Dict
  @test xflat isa Vector
  @test length(xflat) == 3
  @test 1 ∈ xflat && 2 ∈ xflat && [1, 2, 3] ∈ xflat

  @test fleaves((;)) == []
  @test fleaves((; a = 1, b = 2, c = (;))) == [1, 2]
end

@testset "fmap_with_path" begin
  @testset "basic properties" begin
    m = Bar(Foo(Dict("a" => 1, "b" => (b1=2, b2=20)), [3, 4, (5, 6)]))
    res = fmap_with_path((kp, x) -> x^2, m)
    @test res == Bar{Foo}(Foo(Dict("b" => (b1 = 4, b2 = 400), "a" => 1), [9, 16, (25, 36)]))
    res = fmap_with_path((kp, x) -> x isa Number ? x^2 : nothing, m, 
            exclude = (kp, x) -> (kp ∈ (KeyPath(:x, :x, "b"), KeyPath(:x, :y, 3)) || Functors.isleaf(x)))
    @test res == Bar{Foo}(Foo(Dict("b" => nothing, "a" => 1), [9, 16, nothing]))
  end

  @testset "sharing" begin
    shared = [1,2,3]
    m1 = Foo(shared, Foo([1,2,3], Foo(shared, [1,2,3])))
    m1f = fmap_with_path((kp, x) -> float(x), m1)
    @test m1f.x === m1f.y.y.x
    @test m1f.x !== m1f.y.x
    m1no = fmap_with_path((kp, x) -> float(x), m1; cache = nothing)  # disable the cache by hand
    @test m1no.x !== m1no.y.y.x

    # Here "4" is not shared, because Foo isn't leaf:
    m2 = Foo(Foo(shared, 4), Foo(shared, 4))
    @test m2.x === m2.y
    m2f = fmap_with_path((kp, x) -> float(x), m2)
    @test m2f.x.x === m2f.y.x
   
   
    # Shared mutable containers are preserved, even if all children are isbits:
    ref = Ref(1)
    m5 = (x = ref, y = ref, z = Ref(1))
    m5f = fmap_with_path((kp, x) -> x/2, m5)
    @test m5f.x === m5f.y
    @test m5f.x !== m5f.z
  end

  @testset "fmap_with_path(f, x, y)" begin
    m1 = (x = [1,2], y = 3)
    n1 = (x = [4,5], y = 6)
    @test fmap_with_path((kp, x, y) -> x + y, m1, n1) == (x = [5, 7], y = 9)

    # Reconstruction type comes from the first argument
    foo1 = Foo([7,8], 9)
    @test fmap_with_path((kp, x, y) -> x + y, m1, foo1) == (x = [8, 10], y = 12)
    @test fmap_with_path((kp, x, y) -> x + y, foo1, n1) isa Foo
    @test fmap_with_path((kp, x, y) -> x + y, foo1, n1).x == [11, 13]

    # Mismatched trees should be an error
    m2 = (x = [1,2], y = (a = [3,4], b = 5))
    n2 = (x = [6,7], y = 8)
    @test_throws Exception fmap_with_path((kp, x, y) -> x, m2, n2)

    # The cache uses IDs from the first argument
    shared = [1,2,3]
    m3 = (x = shared, y = [4,5,6], z = shared)
    n3 = (x = shared, y = shared, z = [7,8,9])
    @test fmap_with_path((kp, x, y) -> x + y, m3, n3) == (x = [2, 4, 6], y = [5, 7, 9], z = [2, 4, 6])
    z3 = fmap_with_path((kp, x, y) -> x + y, m3, n3)
    @test z3.x === z3.z

    # Pruning of duplicates:
    @test fmap_with_path((kp, x, y) -> x + y, m3, n3; prune = nothing) == (x = [2,4,6], y = [5,7,9], z = nothing)

    # More than two arguments:
    z4 = fmap_with_path((kp, x...) -> +(x...), m3, n3, m3, n3)
    @test z4 == fmap_with_path((kp, x) -> 2x, z3)
    @test z4.x === z4.z

    @test fmap_with_path((kp, x...) -> +(x...), foo1, m1, n1) isa Foo
    @test fmap_with_path((kp, x...) -> .*(x...), m1, foo1, n1) == (x = [4*7, 2*5*8], y = 3*6*9)
  end
end

@testset "fmapstructure_with_path" begin
  @testset "basic properties" begin
    m = Bar(Foo(Dict("a" => 1, "b" => (b1=2, b2=20)), [3, 4, (5, 6)]))
    res = fmapstructure_with_path((kp, x) -> x^2, m)
    @test res == (x = (x = Dict("b" => (b1=4, b2=400), "a" => 1), y = [9, 16, (25, 36)]),)
    res = fmapstructure_with_path((kp, x) -> x isa Number ? x^2 : nothing, m, 
            exclude = (kp, x) -> (kp ∈ (KeyPath(:x, :x, "b"), KeyPath(:x, :y, 3)) || Functors.isleaf(x)))
    @test res == (x = (x = Dict("b" => nothing, "a" => 1), y = [9, 16, nothing]),)
  end

  @testset "sharing" begin
    shared = [1,2,3]
    m1 = Foo(shared, Foo([1,2,3], Foo(shared, [1,2,3])))
    m1p = fmapstructure_with_path((kp,x)->x, m1; prune = nothing)
    @test m1p == (x = [1, 2, 3], y = (x = [1, 2, 3], y = (x = nothing, y = [1, 2, 3])))
    
    # Here "4" is not shared, because Foo isn't leaf:
    m2 = Foo(Foo(shared, 4), Foo(shared, 4))
    @test m2.x === m2.y
    m2p = fmapstructure_with_path((kp,x)->x, m2; prune = Bar(0))
    @test m2p == (x = (x = [1, 2, 3], y = 4), y = (x = Bar{Int64}(0), y = 4))

    # Repeated isbits types should not automatically be regarded as shared:
    m3 = Foo(Foo(shared, 1:3), Foo(1:3, shared))
    m3p = fmapstructure_with_path((kp,x)->x, m3; prune = 0)
    @test m3p.y.y == 0
    @test m3p.y.x == 1:3
  end

  
  @testset "fmapstructure_with_path(f, x, y)" begin
    m1 = (x = [1,2], y = 3)
    n1 = (x = [4,5], y = 6)
    @test fmapstructure_with_path((kp, x, y) -> x + y, m1, n1) == (x = [5, 7], y = 9)

    foo1 = Foo([7,8], 9)
    @test fmapstructure_with_path((kp, x, y) -> x + y, foo1, m1) == (x = [8, 10], y = 12)
  end
end 

function _map(f, x, ys...)
  check_lenghts(x, ys...) || error("all arguments must have at least the same length of the firs one")
  map(f, x, ys...)
end

function check_lenghts(x, ys...)
  n = length(x)
  return all(y -> length(y) >= n, ys)
end

_map(f, x::Dict, ys...) = Dict(k => f(v, (y[k] for y in ys)...) for (k, v) in x)
_map(f, x::D, ys...) where {D<:AbstractDict} = 
  constructorof(D)([k => f(v, (y[k] for y in ys)...) for (k, v) in x]...)

_values(x) = x
_values(x::AbstractDict) = values(x)

_keys(x::D) where {D <: AbstractDict} = constructorof(D)(k => k for k in keys(x))
_keys(x::Tuple) = (keys(x)...,)
_keys(x::AbstractArray) = collect(keys(x))
_keys(x::NamedTuple{Ks}) where Ks = NamedTuple{Ks}(Ks)


"""
    AbstractWalk

Any walk for use with [`fmap`](@ref) should inherit from this type.
A walk subtyping `AbstractWalk` must satisfy the walk function interface:
```julia
struct MyWalk <: AbstractWalk end

function (::MyWalk)(recurse, x, ys...)
  # implement this
end
```
The walk function is called on a node `x` in a Functors tree.
It may also be passed associated nodes `ys...` in other Functors trees.
The walk function recurses further into `(x, ys...)` by calling
`recurse` on the child nodes.
The choice of which nodes to recurse and in what order is custom to the walk.
"""
abstract type AbstractWalk end

"""
    execute(walk, x, ys...)

Execute a `walk` that recursively calls itself, starting at a node `x` in a Functors tree,
as well as optional associated nodes `ys...` in other Functors trees.
Any custom `walk` function that subtypes [`Functors.AbstractWalk`](@ref) is permitted.
"""
function execute(walk::AbstractWalk, x, ys...)
  # This avoids a performance penalty for recursive constructs in an anonymous function.
  # See Julia issue #47760 and Functors.jl issue #59.
  recurse(xs...) = walk(var"#self#", xs...)
  walk(recurse, x, ys...)
end

"""
    DefaultWalk()

The default walk behavior for Functors.jl.
Walks all the [`Functors.children`](@ref) of trees `(x, ys...)` based on
the structure of `x`.
The resulting mapped child nodes are restructured into the type of `x`.

See [`fmap`](@ref) for more information.
"""
struct DefaultWalk <: AbstractWalk end

function (::DefaultWalk)(recurse, x, ys...)
  func, re = functor(x)
  yfuncs = map(y -> functor(typeof(x), y)[1], ys)
  re(_map(recurse, func, yfuncs...))
end

struct DefaultWalkWithPath <: AbstractWalk end

function (::DefaultWalkWithPath)(recurse, kp::KeyPath, x, ys...)
  x_children, re = functor(x)
  kps = _map(c -> KeyPath(kp, c), _keys(x_children)) # use _keys and _map to preserve x_children type
  ys_children = map(children, ys)
  re(_map(recurse, kps, x_children, ys_children...))
end


"""
    StructuralWalk()

A structural variant of [`Functors.DefaultWalk`](@ref).
The recursion behavior is identical, but the mapped children are not restructured.

See [`fmapstructure`](@ref) for more information.
"""
struct StructuralWalk <: AbstractWalk end

function (::StructuralWalk)(recurse, x, ys...)
  x_children = children(x)
  ys_children = map(children, ys)
  return _map(recurse, x_children, ys_children...)
end

struct StructuralWalkWithPath <: AbstractWalk end

function (::StructuralWalkWithPath)(recurse, kp::KeyPath, x, ys...)
  x_children = children(x)
  kps = _map(c -> KeyPath(kp, c), _keys(x_children)) # use _keys and _map to preserve x_children type
  ys_children = map(children, ys)
  return _map(recurse, kps, x_children, ys_children...)
end

"""
    ExcludeWalk(walk, fn, exclude)

A walk that recurses nodes `(x, ys...)` according to `walk`,
except when `exclude(x)` is true.
Then, `fn(x, ys...)` is applied instead of recursing further.

Typically wraps an existing `walk` for use with [`fmap`](@ref).
"""
struct ExcludeWalk{T, F, G} <: AbstractWalk
  walk::T
  fn::F
  exclude::G
end

(walk::ExcludeWalk)(recurse, x, ys...) =
  walk.exclude(x) ? walk.fn(x, ys...) : walk.walk(recurse, x, ys...)

struct ExcludeWalkWithKeyPath{T, F, G} <: AbstractWalk
  walk::T
  fn::F
  exclude::G
end

(walk::ExcludeWalkWithKeyPath)(recurse, kp::KeyPath, x, ys...) =
  walk.exclude(kp, x) ? walk.fn(kp, x, ys...) : walk.walk(recurse, kp, x, ys...)
  

struct NoKeyword end

usecache(::Union{AbstractDict, AbstractSet}, x) =
  isleaf(x) ? anymutable(x) : ismutable(x)
usecache(::Nothing, x) = false

@generated function anymutable(x::T) where {T}
  ismutabletype(T) && return true
  fns = QuoteNode.(filter(n -> fieldtype(T, n) != T, fieldnames(T)))
  subs =  [:(anymutable(getfield(x, $f))) for f in fns]
  return Expr(:(||), subs...)
end

"""
    CachedWalk(walk[; prune])

A walk that recurses nodes `(x, ys...)` according to `walk` and storing the
output of the recursion in a cache indexed by `x` (based on object ID).
Whenever the cache already contains `x`, either:
- `prune` is specified, then it is returned, or
- `prune` is unspecified, and the previously cached recursion of `(x, ys...)`
  returned.

Typically wraps an existing `walk` for use with [`fmap`](@ref).
"""
struct CachedWalk{T, S, C <: AbstractDict} <: AbstractWalk
  walk::T
  prune::S
  cache::C
end
CachedWalk(walk; prune = NoKeyword(), cache = IdDict()) =
  CachedWalk(walk, prune, cache)

function (walk::CachedWalk)(recurse, x, ys...)
  should_cache = usecache(walk.cache, x)
  if should_cache && haskey(walk.cache, x)
    return walk.prune isa NoKeyword ? cacheget(walk.cache, x, recurse, x, ys...) : walk.prune
  else
    ret = walk.walk(recurse, x, ys...)
    if should_cache
      walk.cache[x] = ret
    end
    return ret
  end
end

struct CachedWalkWithPath{T, S, C <: AbstractDict} <: AbstractWalk
  walk::T
  prune::S
  cache::C
end

CachedWalkWithPath(walk; prune = NoKeyword(), cache = IdDict()) =
  CachedWalkWithPath(walk, prune, cache)

function (walk::CachedWalkWithPath)(recurse, kp::KeyPath, x, ys...)
  should_cache = usecache(walk.cache, x)
  if should_cache && haskey(walk.cache, x)
    return walk.prune isa NoKeyword ? cacheget(walk.cache, x, recurse, kp, x, ys...) : walk.prune
  else
    ret = walk.walk(recurse, kp, x, ys...)
    if should_cache
      walk.cache[x] = ret
    end
    return ret
  end
end

"""
    CollectWalk()

A walk that recurses into a node `x` via [`Functors.children`](@ref),
storing the recursion history in a cache.
The resulting ordered recursion history is returned.

See [`fcollect`](@ref) for more information.
"""
struct CollectWalk <: AbstractWalk
  cache::Base.IdSet{Any}
  output::Vector{Any}
end
CollectWalk() = CollectWalk(Base.IdSet(), Any[])

# note: we don't have an `OrderedIdSet`, so we use an `IdSet` for the cache
# (to ensure we get exactly 1 copy of each distinct array), and a usual `Vector`
# for the results, to preserve traversal order (important downstream!).
function (walk::CollectWalk)(recurse, x)
  if usecache(walk.cache, x) && (x in walk.cache)
    return walk.output
  end
  # to exclude, we wrap this walk in ExcludeWalk
  usecache(walk.cache, x) && push!(walk.cache, x)
  push!(walk.output, x)
  _map(recurse, children(x))

  return walk.output
end

"""
    IterateWalk()

A walk that walks all the [`Functors.children`](@ref) of trees `(x, ys...)` 
and concatenates the iterators of the children via
[`Iterators.flatten`](https://docs.julialang.org/en/v1/base/iterators/#Base.Iterators.flatten).
The resulting iterator is returned.

When used with [`fmap`](@ref), the provided function `f` should
return an iterator. For example, to iterate through
the square of every scalar value:
```jldoctest iterate
julia> x = ([1, 2, 3], 4, (5, 6, [7, 8]));

julia> make_iterator(x) = x isa AbstractVector ? x.^2 : (x^2,);

julia> iter = fmap(make_iterator, x; walk=Functors.IterateWalk(), cache=nothing);

julia> collect(iter)
8-element Vector{Int64}:
  1
  4
  9
 16
 25
 36
 49
 64
```
We can also simultaneously iterate through multiple functors:
```@jldoctest iterate
julia> y = ([8, 7, 6], 5, (4, 3, [2, 1]));

julia> make_zipped_iterator(x, y) = zip(make_iterator(x), make_iterator(y));

julia> zipped_iter = fmap(make_zipped_iterator, x, y; walk=Functors.IterateWalk(), cache=nothing);

julia> collect(zipped_iter)
8-element Vector{Tuple{Int64, Int64}}:
 (1, 64)
 (4, 49)
 (9, 36)
 (16, 25)
 (25, 16)
 (36, 9)
 (49, 4)
 (64, 1)
```
"""
struct IterateWalk <: AbstractWalk end

function (walk::IterateWalk)(recurse, x, ys...)
  x_children = children(x)
  ys_children = map(children, ys)
  return Iterators.flatten(_map(recurse, x_children, ys_children...))
end

struct FlattenWalk <: AbstractWalk end

function (walk::FlattenWalk)(recurse, x, ys...)
  x_children = _values(children(x))
  ys_children = map(children, ys)
  res = _map(recurse, x_children, ys_children...)
  return reduce(vcat, _values(res); init = [])
end

@testset "KeyPath" begin
    kp = KeyPath(:a, 3, :b, 4)
    @test (kp...,) === (:a, 3, :b, 4)
    @test length(kp) == 4
    @test kp[1] == :a
    @test kp[2] == 3
    @test kp[3] == :b
    @test kp[4] == 4

    kp2 = KeyPath(:a, kp, :c, 5)
    @test (kp2...,) === (:a, :a, 3, :b, 4, :c, 5)

    kp3 = KeyPath(kp, kp2)
    @test (kp3...,) === (:a, 3, :b, 4, :a, :a, 3, :b, 4, :c, 5)    

    kp0 = KeyPath()
    @test (kp0...,) === ()

    struct Tkp
        a
        b
        c
    end

    function Base.getproperty(x::Tkp, k::Symbol)
        if k in fieldnames(Tkp)
            return getfield(x, k)
        elseif k === :ab
            return "ab"
        else        
            error()
        end
    end

    Base.propertynames(::Tkp) = (:a, :b, :c, :ab)

    @testset "getkeypath" begin
        x = Dict(:a => 3, :b => Dict(:c => 4, "d" => [5, 6, 7]))
        @test getkeypath(x, KeyPath(:a)) == 3
        @test getkeypath(x, KeyPath(:b, :c)) == 4
        @test getkeypath(x, KeyPath(:b, "d", 2)) == 6

        x = Tkp(3, Tkp(4, 5, (6, 7)), 8)
        kp = KeyPath(:b, :c, 2)
        @test getkeypath(x, kp) == 7

        x = [(a=1,) (b=2,)]
        @test getkeypath(x, KeyPath(CartesianIndex(1, 1), :a)) == 1
        @test getkeypath(x, KeyPath(CartesianIndex(1, 2), :b)) == 2

        @testset "access through getproperty" begin
            x = Tkp(3, Dict(:c => 4, :d => 5), 6);

            @test getkeypath(x, KeyPath(:ab)) == "ab"
            @test getkeypath(x, KeyPath(:b, :c)) == 4
        end
    end

    @testset "setkeypath!" begin
        x = Dict(:a => 3, :b => Dict(:c => 4, "d" => [5, 6, 7]))
        setkeypath!(x, KeyPath(:a), 4)
        @test x[:a] == 4
        setkeypath!(x, KeyPath(:b, "d", 1), 17)
        @test x[:b]["d"][1] == 17
        setkeypath!(x, KeyPath(:b, "d"), [0])
        @test x[:b]["d"] == [0]
        
        x = Tkp(3, Tkp(4, 5, [6, 7]), 8)
        kp = KeyPath(:b, :c, 2)
        setkeypath!(x, kp, 17)
        @test x.b.c[2] == 17

        x = [(a=1,) (b=2,)]
        setkeypath!(x, KeyPath(CartesianIndex(1, 2)), (c=3,))
        @test x[2] == (c=3,)
    end

    @testset "haskeypath" begin
        x = Dict(:a => 3, :b => Dict(:c => 4, "d" => [5, 6, 7]))
        @test haskeypath(x, KeyPath(:a))
        @test haskeypath(x, KeyPath(:b, :c))
        @test haskeypath(x, KeyPath(:b, "d", 2))
        @test !haskeypath(x, KeyPath(:b, "d", 4))
        @test !haskeypath(x, KeyPath(:b, "e"))

        x = [(a=1,) (b=2,)]
        @test haskeypath(x, KeyPath(CartesianIndex(1, 1)))
        @test haskeypath(x, KeyPath(CartesianIndex(1, 2)))
        @test !haskeypath(x, KeyPath(CartesianIndex(1, 3)))

        @testset "access through getproperty" begin
            x = Tkp(3, Dict(:c => 4, :d => 5), 6);

            @test haskeypath(x, KeyPath(:ab))
            @test haskeypath(x, KeyPath(:b, :c))
            @test !haskeypath(x, KeyPath(:b, :e))
        end
    end
end

@testset "Numbers are leaves" begin
  @test Functors.isleaf(1)
  @test Functors.isleaf(1.0)
  @test Functors.isleaf(1im)
  @test Functors.isleaf(1//2)
  @test Functors.isleaf(1.0 + 2.0im)
end

@testset "RefValue" begin
  @test fmap(sqrt, Ref(16))[] == 4.0
  @test fmap(sqrt, Ref(16)) isa Ref
  @test fmapstructure(sqrt, Ref(16)) === (x = 4.0,)

  x = Ref(13)
  p, re = Functors.functor(x)
  @test p == (x = 13,)
  @test re(p) isa Base.RefValue{Int}

  x2 = (a = x, b = [7, x, nothing], c = (7, nothing, Ref(13)))
  y2 = fmap(identity, x2)
  @test x2.a !== y2.a  # it's a new Ref
  @test y2.a === y2.b[2]  # relation is maintained
  @test y2.a !== y2.c[3]  # no new relation created

  x3 = Ref([3.14])
  f3 = [Foo(x3, x), x3, x]
  @test f3[1].x === f3[2]
  y3 = fmapstructure(identity, f3)  # replaces mutable with immutable
  @test y3[1].x === y3[2]
  @test y3[1].x.x === y3[2].x
  z3 = fmapstructure(identity, y3)
  @test z3[1].x === z3[2]
  @test z3[1].x.x === z3[2].x
end

@testset "ComposedFunction" begin
  f1 = Foo(1.1, 2.2)
  f2 = Bar(3.3)
  @test Functors.functor(f1 ∘ f2)[1] == (outer = f1, inner = f2)
  @test Functors.functor(f1 ∘ f2)[2]((outer = f1, inner = f2)) == f1 ∘ f2
  @test fmap(x -> x + 10, f1 ∘ f2) == Foo(11.1, 12.2) ∘ Bar(13.3)
end

@testset "Pair, Fix12" begin
    @test fmap(sqrt, 4 => 9) === (2.0 => 3.0)

    exclude = x -> x isa Number
    @test fmap(sqrt, Base.Fix1(/, 4); exclude)(10) == 0.2
    @test fmap(sqrt, Base.Fix2(/, 4); exclude)(10) == 5.0
end

@testset "BroadcastFunction" begin
  f = Bar(3.3)
  bf = Base.Broadcast.BroadcastFunction(f)
  @test Functors.functor(bf)[1] == (f = f,)
  @test Functors.functor(bf)[2]((f = f,)) == bf
  @test fmap(x -> x + 10, bf) == Base.Broadcast.BroadcastFunction(Bar(13.3))
end

@testset "Returns" begin
  ret = Returns([0, pi, 2pi])
  @test Functors.functor(ret)[1] == (value = [0, pi, 2pi],)
  @test Functors.functor(ret)[2]((value = 1:3,)) === Returns(1:3)
end

@testset "Splat" begin
  ret = Base.splat(Returns([0, pi, 2pi]))
  @test Functors.functor(ret)[1].f.value == [0, pi, 2pi]
  @test Functors.functor(ret)[2]((f = sin,)) === Base.splat(sin)
end

@testset "LinearAlgebra containers" begin
  @test fmapstructure(identity, [1,2,3]') == (parent = [1, 2, 3],)
  @test fmapstructure(identity, transpose([1,2,3])) == (parent = [1, 2, 3],)

  CNT = Ref(0)
  fv(x::Vector) = (CNT[]+=1; 10v)

  v = [1,2,3]
  nt = fmap(fv, (a=v, b=v', c=transpose(v), d=[1,2,3]'))

  @test nt.a === adjoint(nt.b)  # does not break tie
  @test nt.a === transpose(nt.c)

  @test CNT[] == 2
  @test nt.a == adjoint(nt.d)  # does not create a new tie
  @test nt.a !== adjoint(nt.d)

  @test nt.b isa Adjoint
  @test nt.c isa Transpose

  x = [1,2,3]'
  xs = fmapstructure(identity, x)  # check it digests this, e.g. structural gradient representation
  @test Functors.functor(typeof(x), xs) == Functors.functor(x)  # (no real need for [2] types to match)

  x = transpose([1 2; 3 4])
  yt = transpose([5 6; 7 8])
  ym = Matrix(yt)  # check it digests this, e.g. simplest Matrix gradient
  @test Functors.functor(typeof(x), yt)[1].parent == Functors.functor(typeof(x), ym)[1].parent

  ybc = Broadcast.broadcasted(+, ym, 9)  # check it digests this, as Optimisers.jl makes these
  collect(ybc) isa Vector
  zbc = Functors.functor(typeof(x), ybc)[1].parent
  @test zbc .+ 0 == Functors.functor(typeof(x), ym .+ 9)[1].parent

  # Similar checks for Adjoint. 
  x = adjoint([1 2im 3; 4im 5 6im])
  yt = adjoint([7im 8 9; 0 im 2])
  ym = Matrix(yt)
  @test Functors.functor(typeof(x), yt)[1].parent == Functors.functor(typeof(x), ym)[1].parent

  ybc = Broadcast.broadcasted(+, ym, [11im, 12, im])
  collect(ybc) isa Vector
  zbc = Functors.functor(typeof(x), ybc)[1].parent
  @test zbc .+ 0 == Functors.functor(typeof(x), ym .+ [11im, 12, im])[1].parent
end

@testset "PermutedDimsArray" begin
  @test fmapstructure(identity, PermutedDimsArray([1 2; 3 4], (2,1))) == (parent = [1 2; 3 4],)
  @test fmap(exp, PermutedDimsArray([1 2; 3 4], (2,1))) isa PermutedDimsArray{Float64}
end

@testset "Iterators" begin
    exclude = x -> x isa Array

    x = fmap(complex, Iterators.map(sqrt, [1,2,3]); exclude)  # Base.Generator
    @test x.iter isa Vector{<:Complex}
    @test collect(x) isa Vector{<:Complex}

    x = fmap(complex, Iterators.accumulate(/, [1,2,3]); exclude)
    @test x.itr isa Vector{<:Complex}
    @test collect(x) isa Vector{<:Complex}

    x = fmap(complex, Iterators.cycle([1,2,3]))
    @test x.xs isa Vector{<:Complex}
    @test first(x) isa Complex

    x = fmap(complex, Iterators.drop([1,2,3], 1); exclude)
    @test x.xs isa Vector{<:Complex}
    @test collect(x) isa Vector{<:Complex}


    x = fmap(complex, Iterators.drop([1,2,3], 1); exclude)
    @test x.xs isa Vector{<:Complex}
    @test collect(x) isa Vector{<:Complex}

    x = fmap(float, Iterators.dropwhile(<(2), [1,2,3]); exclude)
    @test x.xs isa Vector{Float64}
    @test collect(x) isa Vector{Float64}

    x = fmap(complex, enumerate([1,2,3]))
    @test first(x) === (1, 1+0im)

    x = fmap(float, Iterators.filter(<(3), [1,2,3]); exclude)
    @test collect(x) isa Vector{Float64}

    x = fmap(complex, Iterators.flatten(([1,2,3], [4,5])))
    @test collect(x) isa Vector{<:Complex}

    x = fmap(complex, Iterators.partition([1,2,3],2); exclude)
    @test first(x) isa AbstractVector{<:Complex}

    x = fmap(complex, Iterators.product([1,2,3],[4,5]))
    @test first(x) === (1 + 0im, 4 + 0im)

    x = fmap(complex, Iterators.repeated([1,2,3], 4); exclude)  # Iterators.Take{Iterators.Repeated}
    @test first(x) isa Vector{<:Complex}

    x = fmap(complex, Iterators.rest([1,2,3], 2); exclude)
    @test collect(x) isa Vector{<:Complex}

    x = fmap(complex, Iterators.reverse([1,2,3]))
    @test collect(x) isa Vector{<:Complex}

    x = fmap(float, Iterators.takewhile(<(2), [1,2,3]); exclude)
    @test collect(x) isa Vector{Float64}

    x = fmap(complex, zip([1,2,3], [4,5]))
    @test x.is[1] isa Vector{<:Complex}
    @test collect(x) isa Vector{<:Tuple{Complex, Complex}}
end

@testset "AbstractString is leaf" begin
  struct DummyString <: AbstractString
    str::String
  end
  s = DummyString("hello")
  @test Functors.isleaf(s)
end
@testset "AbstractPattern is leaf" begin
  struct DummyPattern <: AbstractPattern
    pat::Regex
  end
  p = DummyPattern(r"\d+")
  @test Functors.isleaf(p)
  @test Functors.isleaf(r"\d+")  
end
@testset "AbstractChar is leaf" begin
  struct DummyChar <: AbstractChar
    ch::Char
  end
  c = DummyChar('a')
  @test Functors.isleaf(c)
  @test Functors.isleaf('a')
end

@testset "AbstractDict is functor" begin
  od = OrderedDict(1 => 1, 2 => 2)
  @test !Functors.isleaf(od)
  od2 = fmap(x -> 2x, od)
  @test od2 isa OrderedDict
  @test od2[1] == 2
  @test od2[2] == 4
end

@testset "Types are leaves" begin
  @test Functors.isleaf(Int)
  @test Functors.isleaf(Array)
  @test fmap(identity, (1,Int,Ref,Array,5)) == (1,Int,Ref,Array,5)
end

using Functors, Test
using Zygote
using LinearAlgebra
using StaticArrays
using OrderedCollections: OrderedDict
using Measurements: ±

@testset "Functors.jl" begin
  include("basics.jl")
  include("base.jl")
  include("keypath.jl")
  include("flexiblefunctors.jl")
  include("cache.jl")
end

struct WalkCache{K, V, W <: AbstractWalk, C <: AbstractDict{K, V}} <: AbstractDict{K, V}
  walk::W
  cache::C
  WalkCache(walk, cache::AbstractDict{K, V} = IdDict()) where {K, V} = new{K, V, typeof(walk), typeof(cache)}(walk, cache)
end
Base.length(cache::WalkCache) = length(cache.cache)
Base.empty!(cache::WalkCache) = empty!(cache.cache)
Base.haskey(cache::WalkCache, x) = haskey(cache.cache, x)
Base.get(cache::WalkCache, x, default) = haskey(cache.cache, x) ? cache[x] : default
Base.iterate(cache::WalkCache, state...) = iterate(cache.cache, state...)
Base.setindex!(cache::WalkCache, value, key) = setindex!(cache.cache, value, key)
Base.getindex(cache::WalkCache, x) = cache.cache[x]

function __cacheget_generator__(world, source, self, cache, x, args #= for `return_type` only =#)
    # :(return cache.cache[x]::(return_type(cache.walk, typeof(args))))
    walk = cache.parameters[3]
    RT = Core.Compiler.return_type(Tuple{walk, args...}, world)
    body = Expr(:call, GlobalRef(Base, :getindex), Expr(:., :cache, QuoteNode(:cache)), :x)
    if RT != Any
        body = Expr(:(::), body, RT)
    end
    expr = Expr(:lambda, [Symbol("#self#"), :cache, :x, :args],
                Expr(Symbol("scope-block"), Expr(:block, Expr(:meta, :inline), Expr(:return, body))))
    ci = ccall(:jl_expand, Any, (Any, Any), expr, @__MODULE__)
    ci.inlineable = true
    if hasfield(Core.CodeInfo, :nargs)
        ci.nargs = 4
        ci.isva = true
    end
    if isdefined(Base, :__has_internal_change) && Base.__has_internal_change(v"1.12-alpha", :codeinfonargs)
        ci.nargs = 4
        ci.isva = true
    end
    return ci
end

@eval function cacheget(cache::WalkCache, x, args...)
    $(Expr(:meta, :generated, __cacheget_generator__))
    $(Expr(:meta, :generated_only))
end

# fallback behavior that only lookup for `x`
@inline cacheget(cache::AbstractDict, x, args...) = cache[x]

Base.@deprecate fmap(walk::AbstractWalk, f, x, ys...) execute(walk, x, ys...)

function fmap(f, x, ys...; exclude = isleaf,
                           walk = DefaultWalk(),
                           cache = IdDict(),
                           prune = NoKeyword())
  _walk = ExcludeWalk(walk, f, exclude)
  if !isnothing(cache)
    _walk = CachedWalk(_walk, prune, WalkCache(_walk, cache))
  end
  execute(_walk, x, ys...)
end

function fmap_with_path(f, x, ys...; exclude = isleaf,
                                     walk = DefaultWalkWithPath(),
                                     cache = IdDict(),
                                     prune = NoKeyword())
  
  _walk = ExcludeWalkWithKeyPath(walk, f, exclude)
  if !isnothing(cache)
    _walk = CachedWalkWithPath(_walk, prune, WalkCache(_walk, cache))
  end
  return execute(_walk, KeyPath(), x, ys...)
end

fmapstructure(f, x, ys...; kwargs...) = fmap(f, x, ys...; walk = StructuralWalk(), kwargs...)

fmapstructure_with_path(f, x, ys...; kwargs...) = fmap_with_path(f, x, ys...; walk = StructuralWalkWithPath(), kwargs...)

fcollect(x; exclude = v -> false) =
  execute(ExcludeWalk(CollectWalk(), _ -> nothing, exclude), x)

fleaves(x; exclude = isleaf) =
  execute(ExcludeWalk(FlattenWalk(), x -> [x], exclude), x)

# We run the benchmarks using AirspeedVelocity.jl

# To run benchmarks locally, first install AirspeedVelocity.jl:
# julia> using Pkg; Pkg.add("AirspeedVelocity"); Pkg.build("AirspeedVelocity")
# and make sure .julia/bin is in your PATH.

# Then commit the changes and run:
# $ benchpkg Functors --rev=mybranch,master --bench-on=mybranch 


using BenchmarkTools: BenchmarkTools, BenchmarkGroup, @benchmarkable, @btime, @benchmark, judge
using ConcreteStructs: @concrete
using Flux: Dense, Chain
using LinearAlgebra: BLAS
using Functors
using Statistics: median

const SUITE = BenchmarkGroup()
const BENCHMARK_CPU_THREADS = Threads.nthreads()
BLAS.set_num_threads(BENCHMARK_CPU_THREADS)


@concrete struct A
    w
    b
    σ
end

struct B
    w
    b
    σ
end

function setup_fmap_bench!(suite)
    a = A(rand(5,5), rand(5), tanh)
    suite["fmap"]["concrete struct"] = @benchmarkable fmap(identity, $a)

    a = B(rand(5,5), rand(5), tanh)
    suite["fmap"]["non-concrete struct"] = @benchmarkable fmap(identity, $a)
    
    a = Dense(5, 5, tanh)
    suite["fmap"]["flux dense"] = @benchmarkable fmap(identity, $a)

    a = Chain(Dense(5, 5, tanh), Dense(5, 5, tanh))
    suite["fmap"]["flux dense chain"] = @benchmarkable fmap(identity, $a)
    
    nt = (layers=(w= rand(5,5), b=rand(5), σ=tanh),)
    suite["fmap"]["named tuple"] = @benchmarkable fmap(identity, $nt)

    return suite
end

setup_fmap_bench!(SUITE)

## AirspeedVelocity.jl will automatically run the benchmarks and save the results
# results = BenchmarkTools.run(SUITE; verbose=true)

module Functors
using Compat: @compat
using ConstructionBase: constructorof
using LinearAlgebra
using Random: AbstractRNG

export @leaf, @functor, @flexiblefunctor,
       fmap, fmapstructure, fcollect, execute, fleaves,
       fmap_with_path, fmapstructure_with_path,
       KeyPath, getkeypath, haskeypath, setkeypath!

@compat(public, (isleaf, children, functor))

include("functor.jl")
include("keypath.jl")
include("walks.jl")
include("cache.jl")
include("maps.jl")
include("base.jl")

###
### Docstrings for basic functionality
###


"""
    functor(x)
    functor(typeof(x), x)

Returns a tuple containing, first, a `NamedTuple` of the children of `x`
(typically its fields), and second, a reconstruction function.
This controls the behaviour of [`fmap`](@ref).

Methods should be added to `functor(::Type{T}, x)` for custom types,
usually using the macro [`@functor`](@ref).
"""
functor

@doc """
    @functor T
    @functor T (x,)

Adds methods to [`functor`](@ref Functors.functor) allowing recursion into objects of type `T`,
and reconstruction. Assumes that `T` has a constructor accepting all of its fields,
which is true unless you have provided an inner constructor which does not.

By default all fields of `T` are considered [`children`](@ref); 
this can be restricted be restructed by providing a tuple of field names.

# Examples
```jldoctest
julia> struct Foo; x; y; end

julia> Functors.children(Foo(1,2))
(x = 1, y = 2)

julia> _, re = Functors.functor(Foo(1,2));

julia> re((10, 20))
Foo(10, 20)

julia> @functor Foo # same as before, nothing changes

julia> struct TwoThirds a; b; c; end

julia> @functor TwoThirds (a, c)

julia> ch2, re3 = Functors.functor(TwoThirds(10,20,30));

julia> ch2
(a = 10, c = 30)

julia> re3(("ten", "thirty"))
TwoThirds("ten", 20, "thirty")

julia> fmap(x -> 10x, TwoThirds(Foo(1,2), Foo(3,4), 56))
TwoThirds(Foo(10, 20), Foo(3, 4), 560)
```
"""
var"@functor"

"""
    isleaf(x)

Return true if `x` has no [`children`](@ref Functors.children) according to [`functor`](@ref Functors.functor).

# Examples
```jldoctest
julia> Functors.isleaf(1)
true

julia> Functors.isleaf([2, 3, 4])
true

julia> Functors.isleaf(["five", [6, 7]])
false

julia> Functors.isleaf([])
false

julia> Functors.isleaf((8, 9))
false

julia> Functors.isleaf(())
true
```
"""
isleaf

"""
    children(x)

Return the children of `x` as defined by [`functor`](@ref Functors.functor).
Equivalent to `functor(x)[1]`.
"""
children

"""
    fmap(f, x, ys...; exclude = Functors.isleaf, walk = Functors.DefaultWalk(), [prune])

A structure and type preserving `map`.

By default it transforms every leaf node (identified by `exclude`, default [`isleaf`](@ref Functors.isleaf))
by applying `f`, and otherwise traverses `x` recursively using [`functor`](@ref Functors.functor).
Optionally, it may also be associated with objects `ys` with the same tree structure.
In that case, `f` is applied to the corresponding leaf nodes in `x` and `ys`.

See also [`fmap_with_path`](@ref) and [`fmapstructure`](@ref).

# Examples
```jldoctest
julia> fmap(string, (x=1, y=(2, 3)))
(x = "1", y = ("2", "3"))

julia> nt = (a = [1,2], b = [23, (45,), (x=6//7, y=())], c = [8,9]);

julia> fmap(println, nt)
[1, 2]
23
45
6//7
()
[8, 9]
(a = nothing, b = Any[nothing, (nothing,), (x = nothing, y = nothing)], c = nothing)

julia> fmap(println, nt; exclude = x -> x isa Array)
[1, 2]
Any[23, (45,), (x = 6//7, y = ())]
[8, 9]
(a = nothing, b = nothing, c = nothing)

julia> twice = [1, 2];  # println only acts once on this

julia> fmap(println, (i = twice, ii = 34, iii = [5, 6], iv = (twice, 34), v = 34.0))
[1, 2]
34
[5, 6]
34
34.0
(i = nothing, ii = nothing, iii = nothing, iv = (nothing, nothing), v = nothing)

julia> d1 = Dict("x" => [1,2], "y" => 3);

julia> d2 = Dict("x" => [4,5], "y" => 6, "z" => "an_extra_value");

julia> fmap(+, d1, d2) == Dict("x" => [5, 7], "y" => 9) # Note that "z" is ignored
true
```

Mutable objects which appear more than once are only handled once (by caching `f(x)` in an `IdDict`).
Thus the relationship `x.i === x.iv[1]` will be preserved.
An immutable object which appears twice is not stored in the cache, thus `f(34)` will be called twice,
and the results will agree only if `f` is pure.

By default, almost all container-like types have children to recurse into. 
Arrays of numbers do not.

To opt out of recursion for custom types use [`@leaf`](@ref) or pass a custom `exclude` function.

```jldoctest withfoo
julia> struct Foo; x; y; end

julia> struct Bar; x; end

julia> m = Foo(Bar([1,2,3]), (4, 5, Bar(Foo(6, 7))));

julia> fmap(x -> 10x, m)
Foo(Bar([10, 20, 30]), (40, 50, Bar(Foo(60, 70))))

julia> fmap(string, m)
Foo(Bar("[1, 2, 3]"), ("4", "5", Bar(Foo("6", "7"))))

julia> fmap(string, m, exclude = v -> v isa Bar)
Foo("Bar([1, 2, 3])", (4, 5, "Bar(Foo(6, 7))"))
```

To recurse into custom types without reconstructing them afterwards,
use [`fmapstructure`](@ref).

For advanced customization of the traversal behaviour,
pass a custom `walk` function that subtypes [`Functors.AbstractWalk`](@ref).
The call `fmap(f, x, ys...; walk = mywalk)` will wrap `mywalk` in
[`ExcludeWalk`](@ref) then [`CachedWalk`](@ref).
Here, [`ExcludeWalk`](@ref) is responsible for applying `f` at excluded nodes.
For a low-level interface for executing a user-constructed walk, see [`execute`](@ref).
```jldoctest withfoo
julia> struct MyWalk <: Functors.AbstractWalk end

julia> (::MyWalk)(recurse, x) = x isa Bar ? "hello" :
                                            Functors.DefaultWalk()(recurse, x)

julia> fmap(x -> 10x, m; walk = MyWalk())
Foo("hello", (40, 50, "hello"))
```

The behaviour when the same node appears twice can be altered by giving a value
to the `prune` keyword, which is then used in place of all but the first:

```jldoctest
julia> twice = [1, 2];

julia> fmap(float, (x = twice, y = [1,2], z = twice); prune = missing)
(x = [1.0, 2.0], y = [1.0, 2.0], z = missing)
```
"""
fmap


###
### Extras
###


"""
    fmapstructure(f, x, ys...; exclude = isleaf, [prune])

Like [`fmap`](@ref), but doesn't preserve the type of custom structs.
Instead, it returns a `NamedTuple` (or a `Tuple`, or an array),
or a nested set of these.

Useful for when the output must not contain custom structs.

See also [`fmap`](@ref) and [`fmapstructure_with_path`](@ref).

# Examples
```jldoctest
julia> struct Foo; x; y; end

julia> m = Foo([1,2,3], [4, (5, 6), Foo(7, 8)]);

julia> fmapstructure(x -> 2x, m)
(x = [2, 4, 6], y = Any[8, (10, 12), (x = 14, y = 16)])

julia> fmapstructure(println, m)
[1, 2, 3]
4
5
6
7
8
(x = nothing, y = Any[nothing, (nothing, nothing), (x = nothing, y = nothing)])
```
"""
fmapstructure

"""
    fcollect(x; exclude = v -> false)

Traverse `x` by recursing each child of `x` as defined by [`functor`](@ref Functors.functor)
and collecting the results into a flat array, ordered by a breadth-first
traversal of `x`, respecting the iteration order of `children` calls.

Doesn't recurse inside branches rooted at nodes `v`
for which `exclude(v) == true`.
In such cases, the root `v` is also excluded from the result.
By default, `exclude` always yields `false`.

See also [`children`](@ref).

# Examples

```jldoctest
julia> struct Foo; x; y; end

julia> struct Bar; x; end

julia> struct TypeWithNoChildren; x; y; end

julia> @leaf TypeWithNoChildren

julia> m = Foo(Bar([1,2,3]), TypeWithNoChildren(:a, :b))
Foo(Bar([1, 2, 3]), TypeWithNoChildren(:a, :b))

julia> fcollect(m)
4-element Vector{Any}:
 Foo(Bar([1, 2, 3]), TypeWithNoChildren(:a, :b))
 Bar([1, 2, 3])
 [1, 2, 3]
 TypeWithNoChildren(:a, :b)

julia> fcollect(m, exclude = v -> v isa Bar)
2-element Vector{Any}:
 Foo(Bar([1, 2, 3]), TypeWithNoChildren(:a, :b))
 TypeWithNoChildren(:a, :b)

julia> fcollect(m, exclude = v -> Functors.isleaf(v))
2-element Vector{Any}:
 Foo(Bar([1, 2, 3]), TypeWithNoChildren(:a, :b))
 Bar([1, 2, 3])
```
"""
fcollect


"""
    fmap_with_path(f, x, ys...; exclude = isleaf, walk = DefaultWalkWithPath(), [prune])

Like [`fmap`](@ref), but also passes a [`KeyPath`](@ref Functors.KeyPath) to `f` for each node in the
recursion. The `KeyPath` is a tuple of the indices used to reach the current
node from the root of the recursion. The `KeyPath` is constructed by the
`walk` function, and can be used to reconstruct the path to the current node
from the root of the recursion.

`f` has to accept two arguments: the associated `KeyPath` and the value of the current node.

`exclude` also receives the `KeyPath` as its first argument and a node as its second.
It should return `true` if the recursion should not continue on its children and `f` applied to it.

`prune` is used to control the behaviour when the same node appears twice, see [`fmap`](@ref)
for more information.

# Examples

```jldoctest
julia> x = ([1, 2, 3], 4, (a=5, b=Dict("A"=>6, "B"=>7), c=Dict("C"=>8, "D"=>9)));

julia> exclude(kp, x) = kp == KeyPath(3, :c) || Functors.isleaf(x);

julia> fmap_with_path((kp, x) -> x isa Dict ? nothing : x.^2, x; exclude = exclude)
([1, 4, 9], 16, (a = 25, b = Dict("B" => 49, "A" => 36), c = nothing))
```
"""
fmap_with_path

"""
    fmapstructure_with_path(f, x, ys...; [exclude, prune])

Like [`fmap_with_path`](@ref), but doesn't preserve the type of custom structs.
Instead, it returns a named tuple, a tuple, an array, a dict, 
or a nested set of these.

See also [`fmapstructure`](@ref).
"""
fmapstructure_with_path


"""
    fleaves(x; exclude = isleaf)

Traverse `x` by recursing each child of `x` as defined by [`functor`](@ref Functors.functor)
and collecting the leaves into a flat array, 
ordered by a breadth-first traversal of `x`, respecting the iteration order of `children` calls.

The `exclude` function is used to determine whether to recurse into a node, therefore
identifying the leaves as the nodes for which `exclude` returns `true`.

See also [`fcollect`](@ref) for a similar function that collects all nodes instead.

# Examples

```jldoctest
julia> struct Bar; x; end

julia> struct TypeWithNoChildren; x; y; end

julia> @leaf TypeWithNoChildren

julia> m = (a = Bar([1,2,3]), b = TypeWithNoChildren(4, 5));

julia> fleaves(m)
2-element Vector{Any}:
 [1, 2, 3]
 TypeWithNoChildren(4, 5)
```
"""
fleaves

end # module

###
### FlexibleFunctors.jl
###

struct FFoo
    x
    y
    p
  end
  @flexiblefunctor FFoo p
  
  struct FBar
    x
    p
  end
  @flexiblefunctor FBar p
  
  struct FOneChild4
    x
    y
    z
    p
  end
  @flexiblefunctor FOneChild4 p
  
  @testset "Flexible Nested" begin
    model = FBar(FFoo(1, [1, 2, 3], (:y, )), (:x,))
  
    model′ = fmap(float, model)
  
    @test model.x.y == model′.x.y
    @test model′.x.y isa Vector{Float64}
  end
  
  @testset "Flexible Walk" begin
    model = FFoo((0, FBar([1, 2, 3], (:x,))), [4, 5], (:x, :y))
  
    model′ = fmapstructure(identity, model)
    @test model′ == (; x=(0, (; x=[1, 2, 3])), y=[4, 5])
  
    model2 = FFoo((0, FBar([1, 2, 3], (:x,))), [4, 5], (:x,))
  
    model2′ = fmapstructure(identity, model2)
    @test model2′ == (; x=(0, (; x=[1, 2, 3])))
  end
  
  @testset "Flexible Property list" begin
    model = FOneChild4(1, 2, 3, (:x, :z))
    model′ = fmap(x -> 2x, model)
  
    @test (model′.x, model′.y, model′.z) == (2, 2, 6)
  end
  
  @testset "Flexible fcollect" begin
    m1 = 1
    m2 = [1, 2, 3]
    m3 = FFoo(m1, m2, (:y, ))
    m4 = FBar(m3, (:x,))
    @test all(fcollect(m4) .=== [m4, m3, m2])
    @test all(fcollect(m4, exclude = x -> x isa Array) .=== [m4, m3])
    @test all(fcollect(m4, exclude = x -> x isa FFoo) .=== [m4])
  
    m0 = NoChild2(:a, :b)
    m1 = [1, 2, 3]
    m2 = FBar(m1, ())
    m3 = FFoo(m2, m0, (:x, :y,))
    m4 = FBar(m3, (:x,))
    @test all(fcollect(m4) .=== [m4, m3, m2, m0])
  end
  

###
### Opt-Out
###

@leaf Type
@leaf Number
@leaf AbstractArray{<:Number}
@leaf AbstractString
@leaf AbstractChar
@leaf AbstractMatch
@leaf AbstractPattern
@leaf AbstractRNG

###
### Fast Paths for common types
###

functor(::Type{<:Tuple}, x) = x, identity
functor(::Type{<:NamedTuple{L}}, x) where L = NamedTuple{L}(map(s -> getproperty(x, s), L)), identity
functor(::Type{<:Dict}, x) = Dict(k => x[k] for k in keys(x)), identity
functor(::Type{<:AbstractArray}, x) = x, identity

# This may be a reasonable default for AbstractDict
# but is not guaranteed to be correct for all dict subtypes
function functor(::Type{D}, x) where {D<:AbstractDict}
  return constructorof(D)([k => x[k] for k in keys(x)]...), identity
end

### 
### Base Types requiring special handling
###

@static if VERSION >= v"1.12-DEV"
  functor(::Type{<:Base.Fix{N}}, x) where N = (; x.f, x.x), y -> Base.Fix{N}(y.f, y.x)
end


###
### Array wrappers
###

# The reason for these is to let W and W' be seen as tied weights in Flux models.
# Can't treat ReshapedArray very well, as its type doesn't include enough details for reconstruction.

functor(::Type{<:Adjoint}, x) = (parent = _adjoint(x),), y -> adjoint(only(y))

_adjoint(x) = adjoint(x)  # _adjoint is the inverse, and also understands more types:
_adjoint(x::NamedTuple{(:parent,)}) = x.parent  # "structural" gradient, and lazy broadcast used by Optimisers:
_adjoint(bc::Broadcast.Broadcasted{S}) where S = Broadcast.Broadcasted{S}(_conjugate(bc.f, adjoint), _adjoint.(bc.args))

functor(::Type{<:Transpose}, x) = (parent = _transpose(x),), y -> transpose(only(y))

_transpose(x) = transpose(x)
_transpose(x::NamedTuple{(:parent,)}) = x.parent
_transpose(bc::Broadcast.Broadcasted{S}) where S = Broadcast.Broadcasted{S}(_conjugate(bc.f, transpose), _transpose.(bc.args))

_conjugate(f::F, ::typeof(identity)) where F = f
_conjugate(f::F, op::Union{typeof(transpose), typeof(adjoint)}) where F = (xs...,) -> op(f(op.(xs)...))

function functor(::Type{<:PermutedDimsArray{T,N,perm,iperm}}, x) where {T,N,perm,iperm}
  (parent = _PermutedDimsArray(x, iperm),), y -> PermutedDimsArray(only(y), perm)
end
function functor(::Type{<:PermutedDimsArray{T,N,perm,iperm}}, x::PermutedDimsArray{Tx,N,perm,iperm}) where {T,Tx,N,perm,iperm}
  (parent = parent(x),), y -> PermutedDimsArray(only(y), perm)  # most common case, avoid wrapping twice.
end

_PermutedDimsArray(x, iperm) = PermutedDimsArray(x, iperm)
_PermutedDimsArray(x::NamedTuple{(:parent,)}, iperm) = x.parent
_PermutedDimsArray(bc::Broadcast.Broadcasted, iperm) = _PermutedDimsArray(Broadcast.materialize(bc), iperm)

using Documenter, Functors

DocMeta.setdocmeta!(Functors, :DocTestSetup, :(using Functors); recursive = true)

makedocs(modules = [Functors],
         sitename = "Functors.jl",
         pages = ["Home" => "index.md",
                  "API" => "api.md"],
         format = Documenter.HTML(
             analytics = "UA-36890222-9",
             assets = ["assets/flux.css"],
             prettyurls = get(ENV, "CI", nothing) == "true"),
         )

deploydocs(repo = "github.com/FluxML/Functors.jl.git",
           target = "build",
           push_preview = true)

```@meta
CurrentModule = Functors
```

# API

```@index
Modules = [Functors]
Pages = ["api.md"]
```

## Constructors and helpers

```@docs
Functors.@functor
Functors.@leaf
Functors.functor
Functors.children
Functors.isleaf
Functors.fcollect
Functors.fleaves
```

## Maps

```@docs
Functors.fmap
Functors.fmap_with_path
Functors.fmapstructure
Functors.fmapstructure_with_path
```

## Walks

```@docs
Functors.AbstractWalk
Functors.execute
Functors.DefaultWalk
Functors.StructuralWalk
Functors.ExcludeWalk
Functors.CachedWalk
Functors.CollectWalk
Functors.IterateWalk
```

## KeyPath

```@docs
Functors.KeyPath
Functors.haskeypath
Functors.getkeypath
Functors.setkeypath!
```

# Functors.jl

Functors.jl provides a set of tools to represent [functors](https://en.wikipedia.org/wiki/Functor_(functional_programming)). Functors are a powerful means to apply functions to generic objects without changing their structure.

The most straightforward use is to traverse a complicated nested structure as a tree, and apply a function `f` to every field it encounters along the way.

For large machine learning models it can be cumbersome or inefficient to work with parameters as one big, flat vector, and structs help manage complexity; but it may be desirable to easily operate over all parameters at once, e.g. for changing precision or applying an optimiser update step.

## Basic Usage and Implementation

By default, Functors.jl is allowed to look into the fields of the instances of any struct and modify them. This can be achieved through [`fmap`](@ref). To opt-out of this behaviour and mark a custom type as non traversable, use the macro [`@leaf`](@ref).

The workhorse of `fmap` is actually a lower level function, [`functor`](@ref Functors.functor):

```julia-repl
julia> using Functors

julia> struct Foo
         x
         y
       end

julia> foo = Foo(1, [1, 2, 3]) # notice all the elements are integers

julia> xs, re = Functors.functor(foo)
((x = 1, y = [1, 2, 3]), var"#21#22"())

julia> re(map(float, xs)) # element types have been switched out for floating point numbers
Foo(1.0, [1.0, 2.0, 3.0])
```

`functor` returns the parts of the object that can be inspected, as well as a reconstruction function (shown as `re`) that takes those values and restructures them back into an object of the original type.

To include only certain fields of a struct, one can pass a tuple of field names to [`@functor`](@ref):

```julia-repl
julia> struct Baz
         x
         y
       end

julia> @functor Baz (x,)

julia> model = Baz(1, 2)
Baz(1, 2)

julia> fmap(float, model)
Baz(1.0, 2)
```

Any field not in the list will be passed through as-is during reconstruction. This is done by invoking the default constructor accepting all fields as arguments, so structs that define custom inner constructors are expected to provide one that acts like the default. 

The use of `@functor` with no fields argument as in `@functor Baz` is equivalent to `@functor Baz fieldnames(Baz)` and also equivalent to avoiding `@functor` altogether.

Using [`@leaf`](@ref) instead of [`@functor`](@ref) will prevent the fields of a struct from being traversed.

!!! warning "Change to opt-out behaviour in v0.5"
    Previous releases of functors, up to v0.4, used an opt-in behaviour where structs were leaves functors unless marked with `@functor`. This was changed in v0.5 to an opt-out behaviour where structs are functors unless marked with `@leaf`.

## Which types are leaves?

By default all composite types in are functors and can be traversed, unless marked with [`@leaf`](@ref). 

The following types instead are explicitly marked as leaves in Functors.jl:
- `Type`
- `Number`.
- `AbstractArray{<:Number}`, except for the wrappers `Transpose`, `Adjoint`, and `PermutedDimsArray`.
- `AbstractRNG`.
- `AbstractString`, `AbstractChar`, `AbstractPattern`, `AbstractMatch`.

This is because in typical application the internals of these are abstracted away and it is not desirable to traverse them.

## What if I get an error?

Since by default Functors.jl tries to traverse most types e.g. when using [`fmap`](@ref), it is possible it fails in case the type has not an appropriate constructor. If use experience this issue, you have a few alternatives:
- Mark the type as a leaf using [`@leaf`](@ref) 
- Use the `@functor` macro to specify which fields to traverse.
- Define an appropriate constructor for the type.

If you are not able to traverse types in julia Base, please open an issue.
